﻿using System.Windows.Media.Imaging;

namespace Async
{
	public static class ImageHelper
	{
		public static BitmapSource ToGrayscale(this BitmapSource source)
		{
			WriteableBitmap wb = new WriteableBitmap(source);
			byte[] pixels = new byte[wb.BackBufferStride * wb.PixelHeight];
			wb.CopyPixels(pixels, wb.BackBufferStride, 0);
			for (int i = 0; i < pixels.Length; i += 4)
			{
				byte color = (byte)((pixels[i] + pixels[i + 1] + pixels[i + 2]) / 3);
				pixels[i] = color;
				pixels[i + 1] = color;
				pixels[i + 2] = color;
			}
			wb.WritePixels(new System.Windows.Int32Rect(0, 0, wb.PixelWidth, wb.PixelHeight), pixels, wb.BackBufferStride, 0);
			return wb;
		}
	}
}
